<?php
/**********************************************************************
***********************************************************************/
include_once($path_to_root . "/includes/ui.inc");
include_once($path_to_root . "/includes/ui/items_cart.inc");

//--------------------------------------------------------------------------------

function add_rmr_to_cart(&$order, $new_item, $new_item_qty, $required_date, $tran_unit, $tran_qty, $convertion_factor)
{
    if ($order->find_cart_item($new_item))
    {
         display_error(_("Item: ") . $new_item . " " . " is already selected.  You can change the quantity of the existing line if necessary.");
    }
    else
    {
        $order->add_to_cart (count($order->line_items), $new_item, $new_item_qty, null, null, null, $required_date,
                 null, 0, 0, 0, 0, 0, null, 0,null, null,null, null, null,$tran_unit, $tran_qty, 
                 $convertion_factor);
    }
}

//--------------------------------------------------------------------------------

function display_rmr_header(&$order)
{
	global $Refs;

	start_outer_table(TABLESTYLE2, "width=70%"); // outer table
	table_section(1);

        locations_list_row(_("Receiving Location:"), 'receiving_location', null);

        table_section(2, "33%");
        ref_row(_("Reference:"), 'rmr_reference', '', $Refs->get_next(ST_RAW_MATERIAL_RETURN));
        
        table_section(3, "33%");
        date_row(_("Date:"), 'rmr_date', '', false);

//
//    if (!isset($_POST['Increase']))
//    	$_POST['Increase'] = 1;
//    yesno_list_row(_("Type:"), 'Increase', $_POST['Increase'],
//    	_("Positive Adjustment"), _("Negative Adjustment"));

	end_outer_table(1); // outer table
}

//---------------------------------------------------------------------------------

function display_rmr_items($title, &$order)
{
	global $path_to_root;

	display_heading($title);
    div_start('items_table');
	start_table(TABLESTYLE, "width=80%");
	$th = array(_("Item Code"), _("Item Description"), _("Quantity"),
		_("Unit"), _("Comment"), "");
	if ( count($order->line_items)) $th[] = '';

	table_header($th);
	$total = 0;
	$k = 0;  //row colour counter

	$id = find_submit('Edit');
	foreach ($order->line_items as $line_no=>$stock_item)
	{

		$total += ($stock_item->standard_cost * $stock_item->quantity);

		if ($id != $line_no)
		{
                    alt_table_row_color($k);

                    view_stock_status_cell($stock_item->stock_id);
                    label_cell($stock_item->item_description);
                    
                    $dec = get_qty_dec($stock_item->stock_id);
                    qty_cell($stock_item->tran_qty, false, get_qty_dec($stock_item->stock_id));
                    if($stock_item->tran_unit == ""){
                        label_cell($stock_item->units);
                    }
                    else{
                        label_cell($stock_item->tran_unit);
                    }

                    edit_button_cell("Edit$line_no", _("Edit"),
                            _('Edit document line'));
                    delete_button_cell("Delete$line_no", _("Delete"),
                            _('Remove line from document'));
                    end_row();
		}
		else
		{
			rmr_edit_item_controls($order, $line_no);
		}
	}

	if ($id == -1)
		rmr_edit_item_controls($order);

	//label_row(_("Total"), number_format2($total,user_price_dec()), "align=right colspan=5", "align=right", 2);

    end_table();
	div_end();
}

//---------------------------------------------------------------------------------

function rmr_edit_item_controls(&$order, $line_no=-1)
{
	global $Ajax;
	start_row();

	$dec2 = 0;
	$id = find_submit('Edit');
	if ($line_no != -1 && $line_no == $id)
	{
		$_POST['stock_id'] = $order->line_items[$id]->stock_id;
		$_POST['qty'] = qty_format($order->line_items[$id]->requested_qty, 
			$order->line_items[$id]->stock_id, $dec);
		$_POST['units'] = $order->line_items[$id]->units;
                $_POST['tran_qty'] = qty_format($order->line_items[$id]->tran_qty, 
			$order->line_items[$id]->stock_id, $dec);

		hidden('stock_id', $_POST['stock_id']);
		label_cell($_POST['stock_id']);
		label_cell($order->line_items[$id]->item_description, 'nowrap');
	    $Ajax->activate('items_table');
	}
	else
	{
    	stock_costable_items_list_cells(null, 'stock_id', null, false, true);
		if (list_updated('stock_id')) {
			    $Ajax->activate('units');
			    $Ajax->activate('qty');
                            $Ajax->activate('issued_qty');
                            $Ajax->activate('tran_unit');
                            $Ajax->activate('tran_qty');
		}

                $item_info = get_item_edit_info($_POST['stock_id']);
            $dec = $item_info['decimals'];
            $_POST['qty'] = number_format2(0, $dec);
            $_POST['std_cost'] = price_decimal_format($item_info["standard_cost"], $dec2);
            $_POST['units'] = $item_info["units"];
            
        }
	qty_cells(null, 'tran_qty', null, null, null, $dec);
        
        if ($line_no != -1 && $line_no == $id)
	{
//            units_list_cells(null, 'tran_unit', $_POST['stock_id'], null, false, true);
            $alternate_unit = get_alternate_unit_details($_POST['tran_unit']);
//            $_POST['std_cost'] = input_num('std_cost');
            if($alternate_unit == ""){
                label_cell($order->line_items[$id]->units);
            }
            else{
                label_cell($order->line_items[$id]->tran_unit);
            }
//            label_cell($alternate_unit['alternate_unit'], '', 'tran_unit');
        }
        else{
            units_list_cells(null, 'tran_unit', $_POST['stock_id'], null, false, true);
//            $alternate_unit = get_alternate_unit_details($_POST['tran_unit']);
//            if($alternate_unit != ""){
//                $convertion_factor = $alternate_unit['convertion_factor'];
//                $_POST['std_cost'] = input_num('std_cost')*$convertion_factor;
//                $_POST['std_cost'] = price_decimal_format($_POST['std_cost'], $dec2);
//            }
            
        }
        hidden('qty', $_POST['qty']);
        hidden('units', $_POST['units']);
        //text_cells('', 'line_comment',null,50);
	//label_cell("&nbsp;");

	if ($id != -1)
	{
		button_cell('UpdateItem', _("Update"),
				_('Confirm changes'), ICON_UPDATE);
		button_cell('CancelItemChanges', _("Cancel"),
				_('Cancel changes'), ICON_CANCEL);
		hidden('LineNo', $line_no);
 		set_focus('qty');
	}
	else
	{
		submit_cells('AddItem', _("Add Item"), "colspan=2",
		    _('Add new item to document'), true);
	}

	end_row();
}


//---------------------------------------------------------------------------------

function rmr_options_controls($mr_cart)
{
	  echo "<br>";
	  start_table();

	  textarea_row(_("Memo"), 'memo_', $mr_cart->memo_, 50, 3);

	  end_table(1);
}

//---------------------------------------------------------------------------------

function view_raw_material_return_header($rmr_no, $suppress_view_link=false)
{
    $myrow = get_raw_material_return_header($rmr_no);

    if (strlen($myrow[0]) == 0)
    {
    	display_note(_("The raw material issue sent is not valid."));
    	exit;
    }

   	start_table(TABLESTYLE, "width=80%");

	$th = array(_("#"), _("Reference"), _("Location"),
			_("Date"), _("Returned By"));

	table_header($th);
	start_row();
	if ($suppress_view_link)
		label_cell($myrow["rmr_no"]);
	else
		label_cell(get_trans_view_str(ST_RAW_MATERIAL_RETURN, $myrow["rmr_no"]));
        
	label_cell($myrow["reference"]);
	label_cell($myrow["location_name"]);
	//view_stock_status_cell($myrow["stock_id"], $myrow["StockItemName"]);
	label_cell(sql2date($myrow["tran_date"]));
        label_cell($myrow["created_user_name"]);

	end_row();

	comments_display_row(ST_RAW_MATERIAL_RETURN, $rmr_no);

	end_table();

}

//---------------------------------------------------------------------------------

function view_material_return_details($rmr_no, $suppress_view_link=false)
{
    $result = get_raw_material_return_details($rmr_no, ST_RAW_MATERIAL_RETURN);

   	start_table(TABLESTYLE, "width=80%");

	$th = array(_("Itemcode"), _("Item Description"), _("Qualtity"));

	table_header($th);
        
        while ($myrow = db_fetch($result)){
            start_row();

            label_cell($myrow["stock_id"]);
            view_stock_status_cell($myrow["stock_id"], $myrow["description"]);

            $quantity = $myrow["qty"];

            $dec = get_qty_dec($myrow["stock_id"]);
            qty_cell($quantity, false, $dec);


            end_row();
        }


	end_table();

}


//---------------------------------------------------------------------------------

?>